Package ghidra.program.database.map

# Class NormalizedAddressSet

java.lang.Object
ghidra.program.database.map.NormalizedAddressSet

All Implemented Interfaces:
  `AddressSetView`, `Iterable<AddressRange>`

public class NormalizedAddressSet extends Object implements AddressSetView
AddressSetView implementation that handles image base changes. NOTE: THIS IMPLEMENTATION ASSUMES THAT ONLY ADDRESS RANGES THAT ARE PART OF THE MEMORY MAP WILL BE ADDED TO THIS ADDRESS SET. IT IS INTENDED FOR USE BY THE CHANGE SET.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `NormalizedAddressSet(AddressMap addrMap)`
  Constructs a NormalizedAddressSet

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `add(Address addr)`
  Adds the address to the set.
  `void`
  `add(AddressRange range)`
  Adds the address range to this set.
  `void`
  `add(AddressSetView set)`
  Adds the addressSet to this set.
  `void`
  `addRange(Address startAddr, Address endAddr)`
  Adds the address range to this set.
  `void`
  `clear()`
  Removes all addresses from this set.
  `boolean`
  `contains(Address addr)`
  Test if the address is contained within this set.
  `boolean`
  `contains(Address startAddr, Address endAddr)`
  Test if the given address range is contained in this set.
  `boolean`
  `contains(AddressSetView rangeSet)`
  Test if the given address set is a subset of this set.
  `void`
  `delete(AddressSetView view)`
  REmoves all the addresses in the given address set from this set.
  `Address`
  `findFirstAddressInCommon(AddressSetView set)`
  Finds the first address in this collection that is also in the given addressSet.
  `AddressIterator`
  `getAddresses(boolean forward)`
  Returns an iterator over all addresses in this set.
  `AddressIterator`
  `getAddresses(Address start, boolean forward)`
  Returns an iterator over the addresses in this address set starting at the start address
  `AddressRangeIterator`
  `getAddressRanges()`
  `AddressRangeIterator`
  `getAddressRanges(boolean forward)`
  Returns an iterator over the ranges in the specified order
  `AddressRangeIterator`
  `getAddressRanges(Address start, boolean forward)`
  Returns an iterator of address ranges starting with the range that contains the given address.
  `AddressRange`
  `getFirstRange()`
  Returns the first range in this set or null if the set is empty
  `AddressRange`
  `getLastRange()`
  Returns the last range in this set or null if the set is empty
  `Address`
  `getMaxAddress()`
  Get the maximum address for this address set.
  `Address`
  `getMinAddress()`
  Get the minimum address for this address set.
  `long`
  `getNumAddresses()`
  `int`
  `getNumAddressRanges()`
  `AddressRange`
  `getRangeContaining(Address address)`
  Returns the range that contains the given address
  `boolean`
  `hasSameAddresses(AddressSetView view)`
  Returns true if the given address set contains the same set of addresses as this set.
  `AddressSet`
  `intersect(AddressSetView view)`
  Computes the intersection of this address set with the given address set.
  `AddressSet`
  `intersectRange(Address start, Address end)`
  Computes the intersection of this address set with the given address range.
  `boolean`
  `intersects(Address start, Address end)`
  Determine if the start and end range intersects with the specified address set.
  `boolean`
  `intersects(AddressSetView addrSet)`
  Determine if this address set intersects with the specified address set.
  `boolean`
  `isEmpty()`
  `Iterator<AddressRange>`
  `iterator()`
  Returns an iterator over the address ranges in this address set.
  `Iterator<AddressRange>`
  `iterator(boolean forward)`
  Returns an iterator over the ranges in the specified order
  `Iterator<AddressRange>`
  `iterator(Address start, boolean forward)`
  Returns an iterator of address ranges starting with the range that contains the given address.
  `AddressSet`
  `subtract(AddressSetView addrSet)`
  Computes the difference of this address set with the given address set (this - set).
  `final String`
  `toString()`
  `AddressSet`
  `union(AddressSetView addrSet)`
  Computes the union of this address set with the given address set.
  `AddressSet`
  `xor(AddressSetView addrSet)`
  Computes the exclusive-or of this address set with the given set.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface ghidra.program.model.address.AddressSetView

  `getAddressCountBefore, spliterator, spliterator, spliterator, stream, stream, stream`

  ### Methods inherited from interface java.lang.Iterable

  `forEach`

- ## Constructor Details

  - ### NormalizedAddressSet

    public NormalizedAddressSet(AddressMap addrMap)
    Constructs a NormalizedAddressSet
    Parameters:
      `addrMap` - the address map

- ## Method Details

  - ### add

    public void add(Address addr)
    Adds the address to the set.
    Parameters:
      `addr` - the address to add

  - ### add

    public void add(AddressSetView set)
    Adds the addressSet to this set.
    Parameters:
      `set` - the set of addresses to add/

  - ### add

    public void add(AddressRange range)
    Adds the address range to this set.
    Parameters:
      `range` - the range to add.

  - ### addRange

    public void addRange(Address startAddr, Address endAddr)
    Adds the address range to this set.
    Parameters:
      `startAddr` - the first address in the range to add.
      `endAddr` - the last address in the range to add.

  - ### clear

    public void clear()
    Removes all addresses from this set.

  - ### delete

    public void delete(AddressSetView view)
    REmoves all the addresses in the given address set from this set.
    Parameters:
      `view` - the set of addresses to remove.

  - ### contains

    public boolean contains(Address addr)
    Description copied from interface: `AddressSetView`
    Test if the address is contained within this set.
    Specified by:
      `contains` in interface `AddressSetView`
    Parameters:
      `addr` - address to test.
    Returns:
      true if addr exists in the set, false otherwise.
    See Also:
      - `AddressSetView.contains(ghidra.program.model.address.Address)`

  - ### contains

    public boolean contains(Address startAddr, Address endAddr)
    Description copied from interface: `AddressSetView`
    Test if the given address range is contained in this set.

    The specified start and end addresses must form a valid range within a single `AddressSpace`.

    Specified by:
      `contains` in interface `AddressSetView`
    Parameters:
      `startAddr` - the first address in the range.
      `endAddr` - the last address in the range.
    Returns:
      true if entire range is contained within the set, false otherwise.
    See Also:
      - `AddressSetView.contains(ghidra.program.model.address.Address, ghidra.program.model.address.Address)`

  - ### contains

    public boolean contains(AddressSetView rangeSet)
    Description copied from interface: `AddressSetView`
    Test if the given address set is a subset of this set.
    Specified by:
      `contains` in interface `AddressSetView`
    Parameters:
      `rangeSet` - the set to test.
    Returns:
      true if the entire set is contained within this set, false otherwise.
    See Also:
      - `AddressSetView.contains(ghidra.program.model.address.AddressSetView)`

  - ### isEmpty

    public boolean isEmpty()
    Specified by:
      `isEmpty` in interface `AddressSetView`
    Returns:
      true if this set is empty.
    See Also:
      - `AddressSetView.isEmpty()`

  - ### getMinAddress

    public Address getMinAddress()
    Description copied from interface: `AddressSetView`
    Get the minimum address for this address set.

    NOTE: An `AddressRange` should generally not be formed using this address and `AddressSetView.getMaxAddress()` since it may span multiple `AddressSpace`s.

    Specified by:
      `getMinAddress` in interface `AddressSetView`
    Returns:
      the minimum address for this set. Returns null if the set is empty.
    See Also:
      - `AddressSetView.getMinAddress()`

  - ### getMaxAddress

    public Address getMaxAddress()
    Description copied from interface: `AddressSetView`
    Get the maximum address for this address set.

    NOTE: An `AddressRange` should generally not be formed using this address and `AddressSetView.getMaxAddress()` since it may span multiple `AddressSpace`s.

    Specified by:
      `getMaxAddress` in interface `AddressSetView`
    Returns:
      the maximum address for this set. Returns null if the set is empty.
    See Also:
      - `AddressSetView.getMaxAddress()`

  - ### getNumAddressRanges

    public int getNumAddressRanges()
    Specified by:
      `getNumAddressRanges` in interface `AddressSetView`
    Returns:
      the number of address ranges in this set.
    See Also:
      - `AddressSetView.getNumAddressRanges()`

  - ### getAddressRanges

    public AddressRangeIterator getAddressRanges()
    Specified by:
      `getAddressRanges` in interface `AddressSetView`
    Returns:
      an iterator over the address ranges in this address set.
    See Also:
      - `AddressSetView.getAddressRanges()`

  - ### iterator

    public Iterator<AddressRange> iterator()
    Description copied from interface: `AddressSetView`
    Returns an iterator over the address ranges in this address set.
    Specified by:
      `iterator` in interface `AddressSetView`
    Specified by:
      `iterator` in interface `Iterable<AddressRange>`

  - ### getAddressRanges

    public AddressRangeIterator getAddressRanges(boolean forward)
    Description copied from interface: `AddressSetView`
    Returns an iterator over the ranges in the specified order
    Specified by:
      `getAddressRanges` in interface `AddressSetView`
    Parameters:
      `forward` - the ranges are returned from lowest to highest, otherwise from highest to lowest
    Returns:
      an iterator over all the addresse ranges in the set.
    See Also:
      - `AddressSetView.getAddressRanges(boolean)`

  - ### getNumAddresses

    public long getNumAddresses()
    Specified by:
      `getNumAddresses` in interface `AddressSetView`
    Returns:
      the number of addresses in this set.
    See Also:
      - `AddressSetView.getNumAddresses()`

  - ### getAddresses

    public AddressIterator getAddresses(boolean forward)
    Description copied from interface: `AddressSetView`
    Returns an iterator over all addresses in this set.
    Specified by:
      `getAddresses` in interface `AddressSetView`
    Parameters:
      `forward` - if true the address are return in increasing order, otherwise in decreasing order.
    Returns:
      an iterator over all addresses in this set.
    See Also:
      - `AddressSetView.getAddresses(boolean)`

  - ### getAddresses

    public AddressIterator getAddresses(Address start, boolean forward)
    Description copied from interface: `AddressSetView`
    Returns an iterator over the addresses in this address set starting at the start address
    Specified by:
      `getAddresses` in interface `AddressSetView`
    Parameters:
      `start` - address to start iterating at in the address set
      `forward` - if true address are return from lowest to highest, else from highest to lowest
    Returns:
      an iterator over the addresses in this address set starting at the start address
    See Also:
      - `AddressSetView.getAddresses(ghidra.program.model.address.Address, boolean)`

  - ### intersects

    public boolean intersects(AddressSetView addrSet)
    Description copied from interface: `AddressSetView`
    Determine if this address set intersects with the specified address set.
    Specified by:
      `intersects` in interface `AddressSetView`
    Parameters:
      `addrSet` - address set to check intersection with.
    Returns:
      true if this set intersects the specified addrSet else false
    See Also:
      - `AddressSetView.intersects(ghidra.program.model.address.AddressSetView)`

  - ### intersects

    public boolean intersects(Address start, Address end)
    Description copied from interface: `AddressSetView`
    Determine if the start and end range intersects with the specified address set.

    The specified start and end addresses must form a valid range within a single `AddressSpace`.

    Specified by:
      `intersects` in interface `AddressSetView`
    Parameters:
      `start` - start of range
      `end` - end of range
    Returns:
      true if the given range intersects this address set.
    See Also:
      - `AddressSetView.intersects(ghidra.program.model.address.Address, ghidra.program.model.address.Address)`

  - ### intersect

    public AddressSet intersect(AddressSetView view)
    Description copied from interface: `AddressSetView`
    Computes the intersection of this address set with the given address set.

    This method does not modify this address set.

    Specified by:
      `intersect` in interface `AddressSetView`
    Parameters:
      `view` - the address set to intersect with.
    Returns:
      AddressSet a new address set that contains all addresses that are contained in both this set and the given set.
    See Also:
      - `AddressSetView.intersect(ghidra.program.model.address.AddressSetView)`

  - ### intersectRange

    public AddressSet intersectRange(Address start, Address end)
    Description copied from interface: `AddressSetView`
    Computes the intersection of this address set with the given address range.

    This method does not modify this address set. The specified start and end addresses must form a valid range within a single `AddressSpace`.

    Specified by:
      `intersectRange` in interface `AddressSetView`
    Parameters:
      `start` - start of range
      `end` - end of range
    Returns:
      AddressSet a new address set that contains all addresses that are contained in both this set and the given range.
    See Also:
      - `AddressSetView.intersectRange(ghidra.program.model.address.Address, ghidra.program.model.address.Address)`

  - ### union

    public AddressSet union(AddressSetView addrSet)
    Description copied from interface: `AddressSetView`
    Computes the union of this address set with the given address set.

    This method does not change this address set.

    Specified by:
      `union` in interface `AddressSetView`
    Parameters:
      `addrSet` - The address set to be unioned with this address set.
    Returns:
      AddressSet A new address set which contains all the addresses from both this set and the given set.
    See Also:
      - `AddressSetView.union(ghidra.program.model.address.AddressSetView)`

  - ### subtract

    public AddressSet subtract(AddressSetView addrSet)
    Description copied from interface: `AddressSetView`
    Computes the difference of this address set with the given address set (this - set).

    Note that this is not the same as (set - this). This method does not change this address set.

    Specified by:
      `subtract` in interface `AddressSetView`
    Parameters:
      `addrSet` - the set to subtract from this set.
    Returns:
      AddressSet a new address set which contains all the addresses that are in this set, but not in the given set.
    See Also:
      - `AddressSetView.subtract(ghidra.program.model.address.AddressSetView)`

  - ### xor

    public AddressSet xor(AddressSetView addrSet)
    Description copied from interface: `AddressSetView`
    Computes the exclusive-or of this address set with the given set.

    This method does not modify this address set.

    Specified by:
      `xor` in interface `AddressSetView`
    Parameters:
      `addrSet` - address set to exclusive-or with.
    Returns:
      AddressSet a new address set containing all addresses that are in either this set or the given set, but not in both sets
    See Also:
      - `AddressSetView.xor(ghidra.program.model.address.AddressSetView)`

  - ### hasSameAddresses

    public boolean hasSameAddresses(AddressSetView view)
    Description copied from interface: `AddressSetView`
    Returns true if the given address set contains the same set of addresses as this set.
    Specified by:
      `hasSameAddresses` in interface `AddressSetView`
    Parameters:
      `view` - the address set to compare.
    Returns:
      true if the given set contains the same addresses as this set.
    See Also:
      - `AddressSetView.hasSameAddresses(ghidra.program.model.address.AddressSetView)`

  - ### toString

    public final String toString()
    Overrides:
      `toString` in class `Object`
    See Also:
      - `Object.toString()`

  - ### getAddressRanges

    public AddressRangeIterator getAddressRanges(Address start, boolean forward)
    Description copied from interface: `AddressSetView`
    Returns an iterator of address ranges starting with the range that contains the given address.

    If there is no range containing the start address, then the first range will be the next range greater than the start address if going forward, otherwise the range less than the start address

    Specified by:
      `getAddressRanges` in interface `AddressSetView`
    Parameters:
      `start` - the address the first range should contain.
      `forward` - true iterators forward, false backwards
    Returns:
      the AddressRange iterator

  - ### getFirstRange

    public AddressRange getFirstRange()
    Description copied from interface: `AddressSetView`
    Returns the first range in this set or null if the set is empty
    Specified by:
      `getFirstRange` in interface `AddressSetView`
    Returns:
      the first range in this set or null if the set is empty

  - ### getLastRange

    public AddressRange getLastRange()
    Description copied from interface: `AddressSetView`
    Returns the last range in this set or null if the set is empty
    Specified by:
      `getLastRange` in interface `AddressSetView`
    Returns:
      the last range in this set or null if the set is empty

  - ### getRangeContaining

    public AddressRange getRangeContaining(Address address)
    Description copied from interface: `AddressSetView`
    Returns the range that contains the given address
    Specified by:
      `getRangeContaining` in interface `AddressSetView`
    Parameters:
      `address` - the address for which to find a range.
    Returns:
      the range that contains the given address.

  - ### iterator

    public Iterator<AddressRange> iterator(Address start, boolean forward)
    Description copied from interface: `AddressSetView`
    Returns an iterator of address ranges starting with the range that contains the given address.

    If there is no range containing the start address, then the first range will be the next range greater than the start address if going forward, otherwise the range less than the start address

    Specified by:
      `iterator` in interface `AddressSetView`
    Parameters:
      `start` - the address that the first range should contain.
      `forward` - true iterators forward, false backwards
    Returns:
      the AddressRange iterator

  - ### iterator

    public Iterator<AddressRange> iterator(boolean forward)
    Description copied from interface: `AddressSetView`
    Returns an iterator over the ranges in the specified order
    Specified by:
      `iterator` in interface `AddressSetView`
    Parameters:
      `forward` - the ranges are returned from lowest to highest, otherwise from highest to lowest
    Returns:
      an iterator over all the address ranges in the set.

  - ### findFirstAddressInCommon

    public Address findFirstAddressInCommon(AddressSetView set)
    Description copied from interface: `AddressSetView`
    Finds the first address in this collection that is also in the given addressSet.
    Specified by:
      `findFirstAddressInCommon` in interface `AddressSetView`
    Parameters:
      `set` - the addressSet to search for the first (lowest) common address.
    Returns:
      the first address that is contained in this set and the given set.